import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Equirment, SearchEquirmentModel } from '../models/equirment.model';
import { ItemDetail } from '../models/itemDetail.model';
import { Observable } from 'rxjs';

@Injectable({ providedIn: 'root' })
export class EquirmentService {

  constructor(private http: HttpClient) { }
  url: string = "http://915e-49-0-64-28.ngrok.io";
  listEquirment: Equirment[] = []

  addEquirment(model: Equirment) {
    // this.listEquirment.push(model);
    console.log("model", model)
    this.http.post(this.url + "/eqment/", model).subscribe(response => {
      console.log(response);
    })
  }

  // bookEquirment(models: ItemDetail){
  //   this.listEquirment.push(models);
  // }

  getListEquirment(): Observable<Equirment[]> {
    return this.http.get<Equirment[]>(this.url + "/eqment/lists");
  }

  searchListEquirment(searchModel: SearchEquirmentModel) {
    this.http.get(this.url + '&startDate=' + searchModel.sDate.split("-")[2] + '-' + searchModel.sDate.split("-")[1] + '-' + searchModel.sDate.split("-")[0] + '&endDate=' + searchModel.eDate.split("-")[2] + '-' + searchModel.eDate.split("-")[1] + '-' + searchModel.eDate.split("-")[0] + '&startTime=' + searchModel.sTime + ':00' + '&endTime=' + searchModel.eTime + ':00').subscribe((response: any) => {
      console.log(response);
      this.listEquirment = response;
    }, error => {
      console.log(error)
      alert("ไม่สามารถค้นหาอุปกรณ์ที่ว่างได้ เนื่องจาก :\n" + error.message)
    })
  }

  // addEquirment(EquirmentModel: Equirment) {
  //   this.http.post(this.url, EquirmentModel).subscribe(response => {
  //     console.log(response);

  //   })


  // }
  deleteEquirment(EquirmentModel: Equirment) {
    this.http.delete(this.url + "/eqment/" + EquirmentModel.eqId).subscribe(response => {
      console.log(response);
      this.getListEquirment()
      alert("ลบข้อมูลอุปกรณ์สำเร็จ")
    })
  }

  updateEquirment(EquirmentModel: Equirment) {
    this.http.put(this.url + "/" + EquirmentModel.eqId, EquirmentModel).subscribe(response => {
      console.log(response);
      alert("อัพเดทข้อมูลอุปกรณ์สำเร็จ")
    })
  }

  updateEquirProfile(model: Equirment) {
    this.listEquirment = this.listEquirment.filter((value, key) => {
      if (value.eqId === model.eqId) {
        value = model;
      }
      return true;
    });
  }

  deleteEquirProfile(row_obj: Equirment) {
    this.listEquirment = this.listEquirment.filter((value, key) => {
      return value.eqId !== row_obj.eqId;
    });
  }

  EquirmentModel(eqId: string) {

  }

}